> ## Documentation Index
> Fetch the complete documentation index at: https://docs.surnex.io/llms.txt
> Use this file to discover all available pages before exploring further.

# Get v1dataforseocatalogcategories 1



## OpenAPI

````yaml https://api.surnex.io/.well-known/openapi.json get /v1/dataforseo/catalog/categories/{category}
openapi: 3.1.0
info:
  title: Surnex API
  version: 0.2.0
servers:
  - url: https://api.surnex.io
security: []
paths:
  /v1/dataforseo/catalog/categories/{category}:
    get:
      tags:
        - v1
      parameters:
        - schema:
            type: string
            minLength: 1
            description: Service category used for grouping and filtering
          required: true
          description: Service category used for grouping and filtering
          name: category
          in: path
        - schema:
            anyOf:
              - type: boolean
              - type: string
                enum:
                  - 'true'
              - type: string
                enum:
                  - 'false'
            default: true
          required: false
          name: discover
          in: query
        - schema:
            type: string
            enum:
              - static
              - discovered
              - mixed
          required: false
          name: discovery_source
          in: query
        - schema:
            type: string
            minLength: 1
            maxLength: 128
          required: false
          name: search
          in: query
        - schema:
            anyOf:
              - type: boolean
              - type: string
                enum:
                  - 'true'
              - type: string
                enum:
                  - 'false'
          required: false
          name: refresh_discovery
          in: query
        - schema:
            type: integer
            exclusiveMinimum: 0
            maximum: 250
            default: 100
          required: false
          name: limit
          in: query
        - schema:
            type:
              - integer
              - 'null'
            minimum: 0
            default: 0
          required: false
          name: offset
          in: query
      responses:
        '200':
          description: >-
            Category-scoped DataForSEO service index with pagination and
            discovery/filter options.
          content:
            application/json:
              schema:
                type: object
                properties:
                  generated_at:
                    type: string
                  discovery_context:
                    type: object
                    properties:
                      requested_discovery:
                        type: boolean
                      force_refresh_requested:
                        type: boolean
                      source:
                        type: string
                        enum:
                          - none
                          - cache
                          - provider
                          - mixed
                      discovered_at:
                        type:
                          - string
                          - 'null'
                      cache_key:
                        type: string
                      cache_ttl_seconds:
                        type: integer
                        exclusiveMinimum: 0
                      cache_available:
                        type: boolean
                      cache_hit:
                        type: boolean
                      provider_calls:
                        type: integer
                        minimum: 0
                    required:
                      - requested_discovery
                      - force_refresh_requested
                      - source
                      - discovered_at
                      - cache_key
                      - cache_ttl_seconds
                      - cache_available
                      - cache_hit
                      - provider_calls
                  category:
                    type: string
                    minLength: 1
                    description: Service category used for grouping and filtering
                  services:
                    type: array
                    items:
                      type: object
                      properties:
                        service:
                          type: string
                          minLength: 1
                        title:
                          type: string
                          minLength: 1
                        category:
                          type: string
                          minLength: 1
                          description: Service category used for grouping and filtering
                        description:
                          type: string
                        examples:
                          type: array
                          items:
                            type: string
                        discovery_source:
                          type: string
                          enum:
                            - static
                            - discovered
                            - mixed
                          description: CatalogDiscoverySource
                        operations:
                          type: array
                          items:
                            type: object
                            properties:
                              service:
                                type: string
                                minLength: 1
                              operation_path:
                                type: string
                                minLength: 1
                              path_template:
                                type: string
                                minLength: 1
                              method:
                                type: string
                                enum:
                                  - GET
                                  - POST
                                description: HTTPMethod
                              mode:
                                type: string
                                enum:
                                  - live
                                  - task_post
                                  - task_get
                                  - tasks_ready
                                  - tasks_fixed
                                description: DataForSeoOperationMode
                              description:
                                type: string
                              discovery_source:
                                type: string
                                enum:
                                  - static
                                  - discovered
                            required:
                              - service
                              - operation_path
                              - path_template
                              - method
                              - mode
                              - description
                      required:
                        - service
                        - title
                        - category
                        - description
                        - examples
                        - operations
                  total_services:
                    type: integer
                    minimum: 0
                  total_operations:
                    type: integer
                    minimum: 0
                  by_discovery_source:
                    type: object
                    properties:
                      static:
                        type: integer
                        minimum: 0
                      discovered:
                        type: integer
                        minimum: 0
                      mixed:
                        type: integer
                        minimum: 0
                    required:
                      - static
                      - discovered
                      - mixed
                  limit:
                    type: integer
                    exclusiveMinimum: 0
                  offset:
                    type: integer
                    minimum: 0
                  returned:
                    type: integer
                    minimum: 0
                  has_more:
                    type: boolean
                  next_offset:
                    type:
                      - integer
                      - 'null'
                    minimum: 0
                  supports_custom_paths:
                    type: boolean
                  supports_any_dataforseo_path:
                    type: boolean
                required:
                  - generated_at
                  - discovery_context
                  - category
                  - services
                  - total_services
                  - total_operations
                  - by_discovery_source
                  - limit
                  - offset
                  - returned
                  - has_more
                  - next_offset
                  - supports_custom_paths
                  - supports_any_dataforseo_path
              examples:
                categoryServices:
                  value:
                    generated_at: '2026-02-24T00:00:00Z'
                    discovery_context:
                      requested_discovery: true
                      force_refresh_requested: false
                      source: provider
                      discovered_at: '2026-02-24T00:00:00Z'
                      cache_key: dataforseo:catalog:discovered:v1
                      cache_ttl_seconds: 900
                      cache_available: true
                      cache_hit: false
                      provider_calls: 2
                    category: keyword_research
                    services:
                      - service: keywords_data
                        category: keyword_research
                        discovery_source: static
                        title: Keywords Data
                        description: Keyword research and metrics
                        examples:
                          - google
                          - bing
                        operations:
                          - service: keywords_data
                            operation_path: /keywords_data/google_ads/search_volume/live
                            path_template: /keywords_data/{provider}/{type}/live
                            method: POST
                            mode: live
                            description: Live search volume
                            discovery_source: static
                          - service: keywords_data
                            operation_path: /keywords_data/google_trends/explore/live
                            path_template: /keywords_data/{type}/explore/live
                            method: POST
                            mode: live
                            description: Live explore data
                            discovery_source: static
                    total_services: 1
                    total_operations: 2
                    by_discovery_source:
                      static: 1
                      discovered: 0
                      mixed: 0
                    limit: 100
                    offset: 0
                    returned: 1
                    has_more: false
                    next_offset: null
                    supports_custom_paths: true
                    supports_any_dataforseo_path: true
        '400':
          description: Invalid request
          content:
            application/json:
              schema:
                type: object
                properties:
                  error:
                    type: object
                    properties:
                      code:
                        type: string
                      message:
                        type: string
                      request_id:
                        type: string
                      details:
                        type: object
                        properties: {}
                        default: {}
                        additionalProperties: {}
                    required:
                      - code
                      - message
                      - request_id
                required:
                  - error
                description: ErrorResponse
              examples:
                badRequest:
                  value:
                    error:
                      code: VALIDATION_ERROR
                      message: Invalid request
                      request_id: req_123
                      details:
                        issues:
                          - path:
                              - limit
                            message: Invalid number
                            code: invalid_type
        '401':
          description: Unauthorized
          content:
            application/json:
              schema:
                type: object
                properties:
                  error:
                    type: object
                    properties:
                      code:
                        type: string
                      message:
                        type: string
                      request_id:
                        type: string
                      details:
                        type: object
                        properties: {}
                        default: {}
                        additionalProperties: {}
                    required:
                      - code
                      - message
                      - request_id
                required:
                  - error
                description: ErrorResponse
              examples:
                unauthorized:
                  value:
                    error:
                      code: UNAUTHORIZED
                      message: Unauthorized
                      request_id: req_123
                      details:
                        reason: missing_or_invalid_api_key
        '404':
          description: Category not found
          content:
            application/json:
              schema:
                type: object
                properties:
                  error:
                    type: object
                    properties:
                      code:
                        type: string
                      message:
                        type: string
                      request_id:
                        type: string
                      details:
                        type: object
                        properties: {}
                        default: {}
                        additionalProperties: {}
                    required:
                      - code
                      - message
                      - request_id
                required:
                  - error
                description: ErrorResponse
              examples:
                notFound:
                  value:
                    error:
                      code: NOT_FOUND
                      message: Category not found
                      request_id: req_123
                      details:
                        category: nonexistent
        '502':
          description: Provider discovery failed
          content:
            application/json:
              schema:
                type: object
                properties:
                  error:
                    type: object
                    properties:
                      code:
                        type: string
                      message:
                        type: string
                      request_id:
                        type: string
                      details:
                        type: object
                        properties: {}
                        default: {}
                        additionalProperties: {}
                    required:
                      - code
                      - message
                      - request_id
                required:
                  - error
                description: ErrorResponse
              examples:
                providerUnavailable:
                  value:
                    error:
                      code: PROVIDER_ERROR
                      message: Failed to discover DataForSEO operations
                      request_id: req_123
                      details:
                        category: serp
                        provider_error:
                          code: BAD_REQUEST
                          message: Discovery endpoint failed
      security:
        - bearerAuth: []
        - apiKeyAuth: []
components:
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer
      bearerFormat: API Key
      description: 'Authorization: Bearer sk_...'
    apiKeyAuth:
      type: apiKey
      in: header
      name: x-api-key

````